



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>深入理解定位父级offsetParent及偏移大小</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">深入理解定位父级offsetParent及偏移大小</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 16:58:14 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h2>前面的话</h2>
<p>　　偏移量(offset dimension)是javascript中的一个重要的概念。涉及到偏移量的主要是offsetLeft、offsetTop、offsetHeight、offsetWidth这四个属性。当然，还有一个偏移参照&mdash;&mdash;定位父级offsetParent。本文将详细介绍该部分内容</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/740839/201609/740839-20160901091826449-1099471755.jpg" /></p>
<h3>定位父级</h3>
<p>　　在理解偏移大小之前，首先要理解offsetParent。人们并没有把offsetParent翻译为偏移父级，而是翻译成定位父级，很大原因是offsetParent与定位有关</p>
<p>　　定位父级offsetParent的定义是：与当前元素最近的经过定位(position不等于static)的父级元素，主要分为下列几种情况</p>
<p>　　【1】元素自身有fixed定位，offsetParent的结果为null</p>
<p>　　当元素自身有<a href="http://www.cnblogs.com/xiaohuochai/p/5321487.html#anchor2" rel="external nofollow noreferrer">fixed固定定位</a>时，我们知道固定定位的元素相对于视口进行定位，此时没有定位父级，offsetParent的结果为<a href="http://www.cnblogs.com/xiaohuochai/p/5665637.html#anchor3" rel="external nofollow noreferrer">null</a></p>
<p>　　[注意]firefox浏览器有兼容性问题</p>
<div>
<pre class="prettyprint linenums">&lt;div id="test" style="position:fixed"&gt;&lt;/div&gt;<br />
&lt;script&gt;<br />
//firefox并没有考虑固定定位的问题，返回&lt;body&gt;，其他浏览器都返回null<br />
console.log(test.offsetParent);<br />
&lt;/script&gt;</pre>
</div>
<p>　　【2】元素自身无fixed定位，且父级元素都未经过定位，offsetParent的结果为&lt;body&gt;</p>
<div>
<pre class="prettyprint linenums">&lt;div id="test"&gt;&lt;/div&gt;<br />
&lt;script&gt;<br />
console.log(test.offsetParent);//&lt;body&gt;<br />
&lt;/script&gt;</pre>
</div>
<p>　　【3】元素自身无fixed定位，且父级元素存在经过定位的元素，offsetParent的结果为离自身元素最近的经过定位的父级元素</p>
<div>
<pre class="prettyprint linenums">&lt;div id="div0" style="position:absolute;"&gt;<br />
    &lt;div id="div1" style="position:absolute;"&gt;<br />
        &lt;div id='test'&gt;&lt;/div&gt;<br />
    &lt;/div&gt;<br />
&lt;/div&gt;<br />
&lt;script&gt;<br />
console.log(test.offsetParent);    //&lt;div id="div1"&gt;<br />
&lt;/script&gt;</pre>
</div>
<p>　　【4】&lt;body&gt;元素的parentNode是null</p>
<div>
<pre class="prettyprint linenums">console.log(document.body.offsetParent);//null</pre>
</div>
<p><strong>IE7-浏览器Bug</strong></p>
<p>　　对于定位父级offsetParent来说，IE7-浏览器存在以下bug</p>
<p>　　【bug1】当元素本身经过<a href="http://www.cnblogs.com/xiaohuochai/p/5312917.html" rel="external nofollow noreferrer">绝对定位</a>或<a href="http://www.cnblogs.com/xiaohuochai/p/5321487.html#anchor1" rel="external nofollow noreferrer">相对定位</a>，且父级元素无经过定位的元素时，IE7-浏览器下，offsetParent是&lt;html&gt;</p>
<div>
<pre class="prettyprint linenums">&lt;div id="test" style="position:absolute;"&gt;&lt;/div&gt;<br />
&lt;script&gt;<br />
//IE7-浏览器返回&lt;html&gt;，其他浏览器返回&lt;body&gt;<br />
console.log(test.offsetParent);<br />
&lt;/script&gt;</pre>
</div>
<div>
<pre class="prettyprint linenums">&lt;div id="test" style="position:relative;"&gt;&lt;/div&gt;<br />
&lt;script&gt;<br />
//IE7-浏览器返回&lt;html&gt;，其他浏览器返回&lt;body&gt;<br />
console.log(test.offsetParent);<br />
&lt;/script&gt;</pre>
</div>
<div>
<pre class="prettyprint linenums">&lt;div id="test" style="position:fixed;"&gt;&lt;/div&gt;<br />
&lt;script&gt;<br />
//firefox并没有考虑固定定位的问题，返回&lt;body&gt;，其他浏览器都返回null<br />
console.log(test.offsetParent);<br />
&lt;/script&gt;</pre>
</div>
<p>　　【bug2】如果父级元素存在触发haslayout的元素或经过定位的元素，且offsetParent的结果为离自身元素最近的经过定位或触发haslayout的父级元素</p>
<p>　　[注意]关于haslayout的详细信息<a href="http://www.cnblogs.com/xiaohuochai/p/4845314.html" rel="external nofollow noreferrer">移步至此</a></p>
<div>
<pre class="prettyprint linenums">&lt;div id="div0" style="display:inline-block;"&gt;<br />
    &lt;div id='test'&gt;&lt;/div&gt;<br />
&lt;/div&gt;<br />
&lt;script&gt;<br />
//IE7-浏览器返回&lt;div id="div0"&gt;，其他浏览器返回&lt;body&gt;<br />
console.log(test.offsetParent);<br />
&lt;/script&gt;</pre>
</div>
<div>
<pre class="prettyprint linenums">&lt;div id="div0" style="position:absolute;"&gt;<br />
    &lt;div id="div1" style="display:inline-block;"&gt;<br />
        &lt;div id='test'&gt;&lt;/div&gt;<br />
    &lt;/div&gt;<br />
&lt;/div&gt;<br />
&lt;script&gt;<br />
//IE7-浏览器返回&lt;div id="div1"&gt;，其他浏览器返回&lt;div id="div0"&gt;<br />
console.log(test.offsetParent);<br />
&lt;/script&gt;</pre>
</div>
<div>
<pre class="prettyprint linenums">&lt;div id="div0" style="display:inline-block;"&gt;<br />
    &lt;div id="div1" style="position:absolute;"&gt;<br />
        &lt;div id='test'&gt;&lt;/div&gt;<br />
    &lt;/div&gt;<br />
&lt;/div&gt;<br />
&lt;script&gt;<br />
//所有浏览器都返回&lt;div id="div1"&gt;<br />
console.log(test.offsetParent);<br />
&lt;/script&gt;</pre>
</div>
<h3>偏移量</h3>
<p>　　偏移量共包括offsetHeight、offsetWidth、offsetLeft、offsetTop这四个属性</p>
<p><strong>offsetWidth</strong></p>
<p>　　offsetWidth表示元素在水平方向上占用的空间大小，无单位(以像素px计)</p>
<div>
<pre class="prettyprint linenums">offsetWidth =  border-left-width + padding-left + width + padding-right + border-right-width; </pre>
</div>
<p><strong>offsetHeight</strong></p>
<p>　　offsetHeight表示元素在垂直方向上占用的空间大小，无单位(以像素px计)</p>
<div>
<pre class="prettyprint linenums">offsetHeight =  border-top-width + padding-top + height + padding-bottom + border-bottom-width</pre>
</div>
<div>
<pre class="prettyprint linenums">&lt;div id="test" style="width:100px; height:100px; padding:10px; margin:10px; border:1px solid black;"&gt;&lt;/div&gt;<br />
&lt;script&gt;<br />
//122=1+10+100+10+1<br />
console.log(test.offsetWidth);<br />
console.log(test.offsetHeight);<br />
&lt;/script&gt;</pre>
</div>
<p>　　[注意]如果存在垂直<a href="http://www.cnblogs.com/xiaohuochai/p/5294409.html" rel="external nofollow noreferrer">滚动条</a>，offsetWidth也包括垂直滚动条的宽度；如果存在水平滚动条，offsetHeight也包括水平滚动条的高度</p>
<div>
<pre class="prettyprint linenums">&lt;div id="test" style="width:100px; height:100px; padding:10px; margin:10px; border:1px solid black; overflow: scroll;"&gt;&lt;/div&gt;<br />
&lt;script&gt;<br />
//IE8-浏览器将垂直滚动条的宽度计算在width宽度和height高度中，width和height的值仍然是100px；<br />
//而其他浏览器则把垂直滚动条的宽度从width宽度中移出，把水平滚动条的高度从height高度中移出，则滚动条宽度为17px，width宽度和height高度为剩下的83px

if(window.getComputedStyle){<br />
    console.log(getComputedStyle(test).width,getComputedStyle(test).height)//83px<br />
}else{<br />
    console.log(test.currentStyle.width,test.currentStyle.height);//100px<br />
}<br />
//122=1+10+100+10+1<br />
console.log(test.offsetWidth,test.offsetHeight);<br />
&lt;/script&gt;</pre>
</div>
<p><strong>offsetTop</strong></p>
<p>　　offsetTop表示元素的上外边框至offsetParent元素的上内边框之间的像素距离</p>
<p><strong>offsetLeft</strong></p>
<p>　　offsetLeft表示元素的左外边框至offsetParent元素的左内边框之间的像素距离</p>
<div>
<pre class="prettyprint linenums">&lt;div id="out" style="padding: 5px;position: relative;background-color: pink;margin: 6px;border:1px solid black"&gt;<br />
    &lt;div id="test" style="width:100px; height:100px; margin:10px;background-color:green;"&gt;&lt;/div&gt;<br />
&lt;/div&gt;<br />
&lt;script&gt;<br />
//15=test.marginTop(10) + out.paddingTop(5)<br />
alert(test.offsetTop);<br />
//15=test.marginLeft(10) + out.paddingLeft(5)<br />
alert(test.offsetLeft);<br />
&lt;/script&gt;    </pre>
</div>
<p><strong>IE7-Bug</strong></p>
<p>　　IE7-浏览器在offsetTop属性的处理上存在bug</p>
<p>　　【1】若父级设置position: relative，则在IE7-浏览器下，offsetTop值为offsetParent元素的paddingBottom值</p>
<div>
<pre class="prettyprint linenums">&lt;div id="out" style="padding: 5px;position: relative;"&gt;<br />
    &lt;div id="test" style="width:100px; height:100px; margin:10px;"&gt;&lt;/div&gt;<br />
&lt;/div&gt;<br />
&lt;script&gt;<br />
//其他浏览器返回15(5+10)，而IE7-浏览器返回5<br />
console.log(test.offsetTop);<br />
&lt;/script&gt;</pre>
</div>
<p>　　【2】若父级设置position: aboslute(或其他触发haslayout的条件)，offsetTop值为offsetParent元素的paddingBottom值和当前元素的marginTop值的较大值</p>
<div>
<pre class="prettyprint linenums">&lt;div id="out" style="padding: 5px;position:absolute;"&gt;<br />
    &lt;div id="test" style="width:100px; height:100px; margin:10px;"&gt;&lt;/div&gt;<br />
&lt;/div&gt;<br />
&lt;script&gt;<br />
//其他浏览器返回15(5+10)，而IE7-浏览器返回10(10和5的较大值)<br />
console.log(test.offsetTop);<br />
&lt;/script&gt;</pre>
</div>
<h3>页面偏移</h3>
<p>　　要知道某个元素在页面上的偏移量，将这个元素的offsetLeft和offsetTop与其offsetParent的相同属性相加，并加上offsetParent的相应方向的边框，如此循环直到根元素，就可以得到元素到页面的偏移量</p>
<p>　　[注意]在默认情况下，IE8-浏览器下如果使用currentStyle()方法获取&lt;html&gt;和&lt;body&gt;(甚至普通div元素)的边框宽度都是medium，而如果使用<a href="http://www.cnblogs.com/xiaohuochai/p/5830053.html#anchor1" rel="external nofollow noreferrer">clientLeft</a>(或clientTop)获取边框宽度，则是实际的数值</p>
<div>
<pre class="prettyprint linenums">html,body{border:;}<br />
body{margin:;}</pre>
</div>
<div>
<pre class="prettyprint linenums">function getElementLeft(element){<br />
    var actualLeft = element.offsetLeft;<br />
    var current = element.offsetParent;<br />
    while(current != null){<br />
        actualLeft += current.offsetLeft + current.clientLeft;<br />
        current = current.offsetParent;<br />
    }<br />
    return actualLeft + 'px';<br />
}<br />
function getElementTop(element){<br />
    var actualTop = element.offsetTop;<br />
    var current = element.offsetParent;<br />
    while(current != null){<br />
        actualTop += current.offsetTop + current.clientTop;<br />
        current = current.offsetParent;<br />
    }<br />
    return actualTop + 'px';<br />
} </pre>
</div>
<div>
<pre class="prettyprint linenums">&lt;div style="padding: 20px;border:1px solid black;position:absolute;"&gt;<br />
    &lt;div id="test" style="width:100px; height:100px; margin:10px;"&gt;&lt;/div&gt;<br />
&lt;/div&gt;<br />
&lt;script&gt;<br />
//其他浏览器返回31(10+20+1)，而IE7-浏览器返回21((20和10的较大值)+1)<br />
console.log(getElementTop(test));<br />
//所有浏览器返回31(10+20+1)<br />
console.log(getElementLeft(test));<br />
&lt;/script&gt;</pre>
</div>
<h3>注意事项</h3>
<p>　　【1】所有偏移量属性都是只读的</p>
<div>
<pre class="prettyprint linenums">&lt;div id="test" style="width:100px; height:100px; margin:10px;"&gt;&lt;/div&gt;<br />
&lt;script&gt;<br />
console.log(test.offsetWidth);//100<br />
//IE8-浏览器会报错，其他浏览器则静默失败<br />
test.offsetWidth = 10;<br />
console.log(test.offsetWidth);//100<br />
&lt;/script&gt;</pre>
</div>
<p>　　【2】如果给元素设置了display:none，则它的偏移量属性都为0</p>
<div>
<pre class="prettyprint linenums">&lt;div id="test" style="width:100px; height:100px; margin:10px;display:none"&gt;&lt;/div&gt;<br />
&lt;script&gt;<br />
console.log(test.offsetWidth);//0<br />
console.log(test.offsetTop);//0<br />
&lt;/script&gt;</pre>
</div>
<p>　　【3】每次访问偏移量属性都需要重新计算</p>
<div>
<pre class="prettyprint linenums">&lt;div id="test" style="width:100px; height:100px; margin:10px;"&gt;&lt;/div&gt;<br />
&lt;script&gt;<br />
console.time("time");<br />
for(var i = 0; i &lt; 100000; i++){<br />
    var a = test.offsetWidth;<br />
}<br />
console.timeEnd('time');//65.129ms<br />
&lt;/script&gt;</pre>
</div>
<div>
<pre class="prettyprint linenums">&lt;div id="test" style="width:100px; height:100px; margin:10px;"&gt;&lt;/div&gt;<br />
&lt;script&gt;<br />
console.time("time");<br />
var a = test.offsetWidth;<br />
for(var i = 0; i &lt; 100000; i++){<br />
    var b = a;<br />
}<br />
console.timeEnd('time');//1.428ms<br />
&lt;/script&gt;</pre>
</div>
<p>　　由上面代码对比可知，重复访问偏移量属性需要耗费大量的性能，所以要尽量避免重复访问这些属性。如果需要重复访问，则把它们的值保存在变量中，以提高性能</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/m960vm39.html">Autofac - 事件</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qnw023q.html">inotifywait命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7jjjkq.html">poj 2278 DNASequnce AC自动机</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnm422q.html">数据库连接池（DBCP&colon;为数据统一建立一个缓冲池，现在企业开发使用）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rddrde8.html">JSON 换行、JSON &bsol;r&bsol;n、怎么处理 ？（转载）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1nwrk8.html">PHP-PCRE正则表达式函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdedwrz9.html">Arduino 电平转换 升压 OUTPUT与9V&sol;12V元件通信</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4y5rm0q.html">Quartz1&period;8&period;5例子（五）</a>
		</li>
						<li><a href="https://www.batexi.com/a/93x25rr9.html">Android开发-解决 AIDL 中找不到couldn&amp;&num;39&semi;t find import for class错误</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kzzv69.html">URAL 1180&period; Stone Game  （博弈 &plus; 规律）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpg6xvq.html">NSString与NSMutableString的浅拷贝与深拷贝</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zojlj9.html">【BZOJ 2713】&lbrack;Violet 2&rsqb;愚蠢的副官&amp;amp&semi;&amp;amp&semi;【BZOJ1183】&lbrack;Croatian2008&rsqb;Umnozak&mdash;&mdash;【数位DP】</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7o7dy18.html">手把手制作一个简单的IDEA插件&lpar;环境搭建Demo篇&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gjx0eq.html">NTSC、PAL、SECAM三大制式简介</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1x64pq.html">PHPCMS V9开发文档</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ppmd6k9.html">&lpar;转&rpar;base64编码是怎么工作的&quest;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8konp77q.html">git客户端msysGit和TortoiseGit使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/8emo30j9.html">CentOS 下安装和使用 Docker</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwlz3jy9.html">读书笔记 effective C&plus;&plus; Item 33 避免隐藏继承而来的名字</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pporez9.html">mybatis小工具</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/e9pd4lz9.html">ACM &colon; POJ 2676 SudoKu DFS - 数独</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8kp71r9.html">unity3D脚本中，update &comma;fixupdate 和lateupdate的区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqdp7kzq.html">mycat入门教程</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqdpn3xq.html">PL&sol;SQL Developer如何连接64位的Oracle图解</a>
			</li>
						<li><a href="https://www.batexi.com/a/0qwj17r8.html">The Practical Guide to Empathy Maps&colon; 10-Minute User Personas</a>
			</li>
						<li><a href="https://www.batexi.com/a/390rvj39.html">利用&commat;media screen实现网页布局的自适应</a>
			</li>
						<li><a href="https://www.batexi.com/a/49gjmg09.html">USACO翻译：USACO 2012 JAN三题（3）</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqv2vlx9.html">C&num;中ToString格式大全</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9j10yw9.html">享元模式 - Flyweight</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqv22no9.html">分布式数据库中的Paxos 算法</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
